package com.bzd.system.service.gxhpz;

import com.bzd.common.config.dao.DaoBase;
import com.bzd.common.config.dao.DaoSupport;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import javax.annotation.Resource;
import java.util.List;

import static com.bzd.common.utils.ShiroUtils.getSysUser;

@Service
public class FollowTaskService {
    @Autowired
    private DaoBase dao;
    @Resource(name = "daoSupport")
    private DaoSupport daoSupport;

    /**
     * 查询列表 
     * @param pd
     * @return 
     * @throws Exception
     */
    public List<PageData> findForList(final PageData pd) throws Exception {
        return (List<PageData>) daoSupport.findForList("followTaskMapper.selectFollowTasks", pd);
    }

    /**
     * 查询单个
     * @param pd
     * @return
     * @throws Exception
     */
    public PageData selectOneById(final PageData pd) throws Exception {
        PageData pdo= (PageData) daoSupport.findForObject("followTaskMapper.selectOneById", pd);
        return pdo;
    }

    /**
     * 添加
     * @param pd
     * @return
     * @throws Exception
     */
    @Transactional(rollbackFor = Exception.class)
    public int save(final PageData pd) throws Exception {
      return  daoSupport.save("followTaskMapper.insertFollowTask", pd);

    }

    /**
     *
     * @param ids
     * @return
     * @throws Exception
     */
    public Integer del(List<String> ids) throws Exception {
        return daoSupport.delete("followTaskMapper.deleteFollowTasksByIds", ids);
    }

    /**
     * 修改配置
     * @param pd
     * @return
     * @throws Exception
     */
    public Integer update(PageData pd) throws Exception {
        return daoSupport.update("followTaskMapper.updateFollowTask", pd);
    }


    /**
     * 关闭任务
     * @param pd
     * @return
     * @throws Exception
     */
    public Integer closeTask(PageData pd) throws Exception {
        pd.put("taskStatus", "已取消");//0待执行，\r\n1已完成，\r\n2未完成，\r\n3已下发，\r\n4已取消
        pd.put("updatedAt", DateUtils.getTime());//'更新时间'
        pd.put("operator", getSysUser().getLoginName());//'操作人'
        int task = daoSupport.update("followTaskMapper.closeTask", pd);
        if (task > 0) {
            return 1;
        } else {
            return -1;
        }
    }


}
